using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;
using System.Windows.Forms;

namespace DesktopText
{
	public class TextIcon
	{
		private string _text;
		private Font _font;
		private Color _foreColor, _backColor;

		public TextIcon()
		{
			_font = new Font("Arial", 8.0F, FontStyle.Regular);
			_foreColor = Color.Black;
			_backColor = Color.Transparent;
			_text = "X";
		}
		public Icon GetIcon()
		{
			string errDetail = "";
			Bitmap bm = null;
			try
			{
				errDetail = "Couldn't create Bitmap object";
				bm = new Bitmap(16, 16);

				errDetail = "Couldn't create Graphics object";
				Graphics g = Graphics.FromImage(bm);

				errDetail = "Couldn't create Brush object";
				Brush b = new SolidBrush(_foreColor);

				errDetail = "Couldn't create StringFormat object";
				StringFormat sf = new StringFormat();
				sf.Alignment = StringAlignment.Center;
				sf.LineAlignment = StringAlignment.Center;

				errDetail = "Couldn't create Rectangle object";
				Rectangle r = new Rectangle(new Point(0, 0), new Size(24, 16));

				if (_backColor != Color.Transparent)
					g.DrawRectangle(new Pen(new SolidBrush(_backColor)), r);

				if (_text.Length > 2)
					_font = new Font("Arial Narrow", 8.0F, FontStyle.Regular);

				errDetail = "Couldn't call Graphics.DrawString method";
				g.TranslateTransform(-3F, 0F);
				g.DrawString(_text, _font, b, r, sf);

				IntPtr ip = bm.GetHicon();
				return Icon.FromHandle(ip);
			}
			catch (Exception ex)
			{
				throw new Exception(errDetail, ex);
			}
		}
		public string Text
		{
			get { return _text; }
			set { _text = value; }
		}
		public Color ForeColor
		{
			get { return _foreColor; }
			set { _foreColor = value; }
		}
		public Color BackColor
		{
			get { return _backColor; }
			set { _backColor = value; }
		}
		private void UpdateSysTrayTemp()
		{
			//string errorDetail = "";
			//try
			//{
			//    NotifyIcon i = null;//uxTemperatureNotifyIcon;

			//    if (i.Visible)
			//    {
			//        //ConditionsPanel p = uxConditionsPanel;

			//        errorDetail = "Couldn't retrieve temperature";
			//        //string t = p.Temperature.ToString();

			//        errorDetail = "Couldn't set font";
			//        Font f;
			//        if (t.Length > 2)
			//            f = new Font("Arial Narrow", 8F, FontStyle.Regular);
			//        else
			//            f = new Font("Arial", 8F, FontStyle.Regular);

			//        errorDetail = "Couldn't build icon object";
			//        i.Icon = null;
			//        i.Icon = new TextIcon(t, f, Color.Black).GetIcon();

			//        //errorDetail = "Couldn't retrieve station name";
			//        //string s = p.Conditions.Station.Name;

			//        //errorDetail = "Couldn't retrieve station's city and state";
			//        //s += "\n" + p.Conditions.Station.CityAndState;

			//        //errorDetail = "Couldn't retreive server timestamp";
			//        //s += " at " + p.Conditions.ServerTimeStamp.ToString("h:mmtt");

			//        errorDetail = "Couldn't truncate tooltip text";
			//        if (s.Length > 64) s = s.Substring(0, 64);

			//        errorDetail = "Couldn't set tooltip text";
			//        i.Text = s;
			//    }

			//}
			//catch (Exception ex)
			//{
			//    //ExceptionHandler.Show(ex, errorDetail, _notifyIcon);
			//}

		}
	
	}
}
